<?php

/**
 * Promotion Custom Customizer
 *
 * @author LeapIn Corp.
 * @since 1.0.0
 */
class LEAPIN_Promotion_Customize_Control extends WP_Customize_Control
{
    public $type = 'leapin-promotion';

    public function render_content()
    {
        ?>
        <h2 class="title"><?php _e('Upgrade To Pro', 'pjax-blog'); ?></h2>
        <p class="description"><?php echo esc_html__('Pjax Blog Pro makes your blog perfect with ease:)', 'pjax-blog'); ?></p>
        <h3 class="title"><?php _e('Features', 'pjax-blog'); ?></h3>
        <ul>
            <li><?php _e('- 60+ Pjax Animations.', 'pjax-blog'); ?></li>
            <li><?php _e('- 10 News Feed Layouts.', 'pjax-blog'); ?></li>
            <li><?php _e('- AMP Auto-Generation(Beta).', 'pjax-blog'); ?></li>
            <li><?php _e('- SNS button Design Customization.', 'pjax-blog'); ?></li>
            <li><?php _e('- Scroll Animation Customization.', 'pjax-blog'); ?></li>
            <li><?php _e('- A Bunch of Webfonts to Choose.', 'pjax-blog'); ?></li>
            <li><?php _e('- Secondary Menu Area.', 'pjax-blog'); ?></li>
            <li><?php _e('- Analytics and Tag Manager Support.', 'pjax-blog'); ?></li>
            <li><?php _e('- One-Click Setup Design Templates for Pro.', 'pjax-blog'); ?></li>
            <li><?php _e('- Uncompiled SCSS files.', 'pjax-blog'); ?></li>
            <li><a href="https://demo.leap-in.com/pjax-blog-1/category/features/pro-edition/" target="_blank"><?php echo esc_html__('And More...', 'pjax-blog'); ?></a>
            </li>
        </ul>
        <h3 class="title"><?php _e('See Demo', 'pjax-blog'); ?></h3>
        <a class="flat_white_btn" href="https://demo.leap-in.com/pjax-blog-1/"
           target="_blank"><?php echo esc_html__('Demo 1', 'pjax-blog'); ?></a>
        <a class="flat_white_btn" href="https://demo.leap-in.com/pjax-blog-2/"
           target="_blank"><?php echo esc_html__('Demo 2', 'pjax-blog'); ?></a>
        <a class="flat_white_btn" href="https://demo.leap-in.com/pjax-blog-3/"
           target="_blank"><?php echo esc_html__('Demo 3', 'pjax-blog'); ?></a>
        <a class="flat_white_btn" href="https://demo.leap-in.com/pjax-blog-4/"
           target="_blank"><?php echo esc_html__('Demo 4', 'pjax-blog'); ?></a>
        <h3 class="title"><?php _e('Learn More', 'pjax-blog'); ?></h3>
        <div class="promotion-flex-row">
            <a class="square_btn" href="https://leap-in.com/"
               target="_blank"><?php echo esc_html__('Go Site', 'pjax-blog'); ?></a>
            <a class="square_btn red" href="https://leap-in.com/product/pjax-blog-pro/"
               target="_blank"><?php echo esc_html__('Get Pro', 'pjax-blog'); ?></a>
        </div>
        <?php
    }
}
