<?php
/**
 * Predefine FIle for one click demo importer
 *
 * @author LeapIn Corp.
 * @since 1.0.0
 */
function leapin_ocdi_import_files()
{
    $demos = [];
    $demo_contents = trailingslashit( get_template_directory() ) . "demo_contents/";
    if(file_exists($demo_contents)){
        $demos[] = array(
            'import_file_name' => 'Template Import Free',
            'categories' => array('Free'),
            'local_import_file'            => $demo_contents . 'free/pjax-blog.xml',
            'local_import_widget_file'     => $demo_contents . 'free/pjax-blog.wie',
            'local_import_customizer_file' => $demo_contents . 'free/pjax-blog.dat',
            'import_preview_image_url' => trailingslashit( get_template_directory_uri() ) . 'demo_contents/free/pjax-blog.png',
            'preview_url' => 'https://demo.leap-in.com/pjax-blog-free/',
        );
    }

    return apply_filters('leapin_ocdi_demos', $demos);
}

add_filter('pt-ocdi/import_files', 'leapin_ocdi_import_files');

/**
 * Set menu and front page, posts page
 */
function leapin_ocdi_after_import_setup()
{
    // Assign menus to their locations.
    $main_menu = get_term_by('name', 'Primary', 'nav_menu');
    $secondary_menu = get_term_by('name', 'Secondary', 'nav_menu');
    $mobile_menu = get_term_by('name', 'Mobile', 'nav_menu');

    set_theme_mod('nav_menu_locations', array(
            'main-nav' => $main_menu->term_id,
            'secondary-nav' => $secondary_menu->term_id,
            'mobile-nav' => $mobile_menu->term_id,
        )
    );

    // Assign front page and posts page (blog page).
    $front_page_id = get_page_by_title('Home');
    $blog_page_id = get_page_by_title('Blog');

    update_option('show_on_front', 'page');
    update_option('page_on_front', $front_page_id->ID);
    update_option('page_for_posts', $blog_page_id->ID);

}

add_action('pt-ocdi/after_import', 'leapin_ocdi_after_import_setup');