<?php
/*
 * This is the default post format.
 *
 * So basically this is a regular post. if you don't want to use post formats,
 * you can just copy ths stuff in here and replace the post format thing in
 * single.php.
 *
 * @author LeapIn Corp.
 * @since 1.0.0
 */
?>
<article id="post-<?php the_ID(); ?>" <?php post_class('cf single'); ?> <?php echo implode(" ", apply_filters('leapin_single_custom_article_tag', [])); ?>
         data-post_id="<?php the_ID(); ?>" role="article" itemprop="blogPost" itemscope
         itemtype="http://schema.org/BlogPosting">

    <?php do_action('leapin_loc_top_of_article'); ?>

    <?php echo LEAPIN_Single_Tags::get_header('in_article'); ?>

    <section class="entry-content cf" itemprop="articleBody">
        <!-- widget area for above single content -->
        <div class="above-single-content">
            <?php if (is_active_sidebar('above_single_content') && !LEAPIN_AMP_Tags::is_amp()) : ?>
                <?php dynamic_sidebar('above_single_content'); ?>
            <?php endif; ?>
        </div>
        <?php

        do_action('leapin_loc_single_above_content');

        // the content (pretty self explanatory huh)
        the_content();

        do_action('leapin_loc_single_below_content');

        if (!is_page()):
            wp_link_pages(array(
                'before' => '<div class="page-links">',
                'after' => '</div>',
                'link_before' => '<span>',
                'link_after' => '</span>',
            ));
        endif;
        ?>
    </section> <?php // end article section ?>

    <?php $footer_visible = LEAPIN_Single_Tags::is_article_footer_enable() ? "" : " sr-only"; ?>
    <footer class="article-footer entry-footer<?php echo $footer_visible; ?>">
        <h2 class="sr-only article-meta">Article Meta</h2>
        <?php if (!is_page()): ?>
            <div class="entry-meta">

                <?php do_action('leapin_loc_article_top_of_footer') ?>

                <div class="entry-cats-tags cf">
                    <?php // categories and tags ?>
                    <?php $hide_categories = leapin_mod_sr_only(LEAPIN_IDs::$leapin_hide_category_below_content); ?>
                    <?php printf('<p class="entry-categories' . $hide_categories . '"><span class="categories-title"><span class="categories" itemprop="keywords">%1$s</span>', get_the_category_list(', ')); ?>
                    <?php $hide_tags = leapin_mod_sr_only(LEAPIN_IDs::$leapin_hide_tag_below_content); ?>
                    <?php the_tags('<p class="entry-tags' . $hide_tags . '" itemprop="keywords">', ', ', '</p>'); ?>
                    <?php // categories and tags end ?>
                </div>
                <!-- widget area for above single footer content -->
                <div id="above-single-footer-meta">
                    <?php if (is_active_sidebar('above_single_footer_meta') && !LEAPIN_AMP_Tags::is_amp()) : ?>
                        <?php dynamic_sidebar('above_single_footer_meta'); ?>
                    <?php endif; ?>
                </div>
                <?php // next and prev post tags ?>
                <?php echo leapin_get_neighbor_posts_tag(); ?>
                <?php // next and prev post tags end ?>
                <?php // author info ?>
                <?php $hide_author_section = leapin_mod_sr_only(LEAPIN_IDs::$leapin_hide_author_section_below_content); ?>
                <h3 class="widget-title sr-only"><?php _e('Author', 'pjax-blog'); ?></h3>
                <?php LEAPIN_Single_Tags::get_author_section($hide_author_section); ?>
                <?php // end author info ?>


                <?php // comments ?>
                <?php if (!LEAPIN_AMP_Tags::is_amp()
                    && leapin_is_comment_open()): ?>
                    <div class="entry-comments">
                        <?php comments_template(); ?>
                    </div>
                <?php endif; ?>
                <?php // end comments ?>

                <?php // publisher markup for better SEO ?>
                <?php LEAPIN_Single_Tags::the_publisher_markup(); ?>
                <?php // end publisher markup ?>

            </div>
        <?php endif; ?>

        <!-- widget area for below single content -->
        <div id="below-single-content">
            <?php if (is_active_sidebar('below_single_content') && !LEAPIN_AMP_Tags::is_amp()) : ?>
                <?php dynamic_sidebar('below_single_content'); ?>
            <?php endif; ?>
        </div>

        <?php do_action('leapin_loc_article_end_of_footer'); ?>

    </footer> <?php // end article footer ?>

    <?php do_action('leapin_loc_end_of_article'); ?>

</article> <?php // end article ?>
