<?php

/**
 * Class LEAPIN_Query_Posts
 *
 * @author LeapIn Corp.
 * @since  1.9.0
 */
class LEAPIN_Query_Posts extends LEAPIN_Query
{
    public function __construct($instance = false, $args = [], $the_query = false)
    {
        parent::__construct($instance, $args, $the_query);

    }

    public function ajax_or_print()
    {
        if ($this->ajax_on_load_call) {
            $this->ajax_call_tag();
        } else {
            $this->the_leapin_posts();
        }
    }

    public function ajax_call_tag()
    {
        echo $this->get_leapin_posts_container_before();
        ?>
        <?php
        echo $this->get_leapin_posts_container_after();
        echo $this->widget_args['after_widget'];
    }


    public function the_leapin_posts()
    {
        $rtn = $this->get_leapin_posts();
        if ($this->call_with_ajax) {
            return json_encode($rtn);
        } else {
            echo $rtn['content'];
        }
    }

    private function get_leapin_posts_container_before()
    {
        $val = $this->widget_args['before_widget'];
        $val .= sprintf('<div id="inner-%s" class="card__cn %s"'
            , $this->widget_args['widget_id']
            , $this->layout_type);

        foreach ($this as $key => $value) {
            if ((!empty($value) || $value === 0) && !is_object($value)) {
                if ($key == 'paged') {
                    if ($this->ajax_on_load_call) {
                        $val .= sprintf(' data-%s="%s"', $key, 0);
                    } else {
                        $val .= sprintf(' data-%s="%s"', $key, 1);
                    }
                } else if (is_array($value)) {
                    $val .= sprintf(' data-%s="%s"', $key, implode(",", $this->term_ids_or_slugs));

                } else {
                    $val .= sprintf(' data-%s="%s"', $key, $value);
                }

            }
        }
        $val .= ' data-ajax="leapin_posts"';
        $val .= '>';
        $title = $this->title;
        if ($title) {
            $val .= $this->widget_args['before_title'] . $title . $this->widget_args['after_title'];
        }

        $w_cls = $this->is_magazine ? " swiper-wrapper" : "";
        $w_cls .= empty($this->is_swipper) ? " opacity-1" : "";


        $this->set_custom_css();

        return $val . sprintf('<div class="card__w%s">', $w_cls);
    }

    private function get_leapin_posts_container_after()
    {
        $echo = "</div>";
        $echo .= "</div>";
        return $echo;
    }

    private function set_custom_css()
    {
        $widget_id = $this->widget_id;
        $grayscale = $this->grayscale;
        $theme_color = $this->theme_color;
        $layout_type = $this->layout_type;

        if (isset($widget_id)) {
            // set grayscale of thumbnail
            if (!empty($grayscale) && $grayscale !== '0') {
                add_filter('leapin_load_css_on_each_pjax', function ($css) use ($widget_id, $grayscale) {
                    $css .= "#inner-$widget_id .card__thumbnail::after{filter: grayscale($grayscale%);}";
                    return $css;
                });
            }
            if (isset($theme_color)) {
                add_filter('leapin_load_css_on_each_pjax', function ($css) use ($widget_id, $theme_color, $layout_type) {
                    if (empty($theme_color)) return $css;

                    $lighten_theme_color = leapin_adjust_color_brightness($theme_color, 30);
                    $rgba3_theme_color = leapin_hex2rgba($theme_color, 0.3);
                    $rgba5_theme_color = leapin_hex2rgba($theme_color, 0.5);
                    $rgba8_theme_color = leapin_hex2rgba($theme_color, 0.8);

                    if ($layout_type == LEAPIN_Query_Params::$SWIPER_VER3) {
                        $css .= "#inner-$widget_id .card__more {background-color: $theme_color;}";
                        $css .= "#inner-$widget_id .card__header::after {background-color: $lighten_theme_color;}";
                    }
                    if ($layout_type == LEAPIN_Query_Params::$SWIPER_VER1) {
                        $css .= "#inner-$widget_id .card__more {background-color: $theme_color;}";
                    }
                    if ($layout_type == LEAPIN_Query_Params::$TILE_VER1) {
                        $css .= "#inner-$widget_id .card__taxonomy.meta_font a {color: $theme_color;}";
                        $css .= "#inner-$widget_id .card__taxonomy.meta_bg a {background: $theme_color;}";
                    }
                    if ($layout_type == LEAPIN_Query_Params::$SWIPER_VER4) {
                        $css .= "#inner-$widget_id .card__more {background-color: $theme_color; box-shadow: 0px 14px 80px $theme_color;}";
                        $css .= "#inner-$widget_id .card__w::before {background-color: $lighten_theme_color;box-shadow: 0 5px 40px -12px $rgba5_theme_color;}";
                        $css .= "#inner-$widget_id .swiper-pagination-bullet-active {background-color: $rgba8_theme_color;}";
                    }
                    if ($this->is_magazine
                        || in_array($layout_type, [LEAPIN_Query_Params::$TILE_VER6, LEAPIN_Query_Params::$SWIPER_VER2])) {
                        $css .= "#inner-$widget_id .swiper-button-prev,#inner-$widget_id .swiper-button-next  {background: $rgba3_theme_color;}";
                        $css .= "#inner-$widget_id .swiper-button-prev:hover,#inner-$widget_id .swiper-button-next:hover  {background: $rgba8_theme_color;}";
                    }
                    if ($layout_type === LEAPIN_Query_Params::$SWIPER_VER5) {
                        $css .= "#inner-$widget_id .terms {background: $theme_color;}";
                    }
                    if (in_array($layout_type, [
                        LEAPIN_Query_Params::$TILE_VER2
                        , LEAPIN_Query_Params::$TILE_VER3
                        , LEAPIN_Query_Params::$TILE_VER4
                        , LEAPIN_Query_Params::$TILE_VER5
                        , LEAPIN_Query_Params::$TILE_VER6
                        , LEAPIN_Query_Params::$SWIPER_VER2
                        , LEAPIN_Query_Params::$SIDEBAR_VER1])
                    ) {
                        $css .= "#inner-$widget_id .card__taxonomy a {color: $theme_color;}";
                    }
                    if (in_array($layout_type, [LEAPIN_Query_Params::$TILE_VER3, LEAPIN_Query_Params::$TILE_VER6])) {
                        $css .= "#inner-$widget_id .ajax-more-posts {background-color: $rgba3_theme_color;}";
                        $css .= "#inner-$widget_id .ajax-more-posts:hover {background-color: $rgba8_theme_color;}";
                    }
                    return $css;
                });
            }
        }
    }

    private function get_leapin_posts()
    {
        $rtn = ['content' => ''];
        $paged = $this->paged;
        $call_with_ajax = $this->call_with_ajax;
        $the_query = is_object($this->the_query) ? $this->the_query : new WP_Query($this->args);

        if ($the_query->have_posts()) {
            if (!$call_with_ajax && !$paged) {
                $rtn['content'] .= $this->get_leapin_posts_container_before();
            }

            /*
             * background image loop
             */
            if ($this->is_swipper_separated) {
                while ($the_query->have_posts()) : $the_query->the_post();
                    $rtn['content'] .= $this->get_background_ul($the_query);
                endwhile;
            }
            /*
             * main loop
             */
            while ($the_query->have_posts()) : $the_query->the_post();
                $rtn['content'] .= $this->get_card_ul($the_query);
                $this->loop++;
            endwhile;

            $rtn['is_more_posts'] = $this->is_more_posts($the_query);
            $rtn['post_count'] = $the_query->post_count;


            if (!$call_with_ajax && !$paged) {
                $rtn['content'] .= $this->get_leapin_posts_container_after();
                $rtn['content'] .= $this->widget_args['after_widget'];
            }
        }
        wp_reset_postdata();

        $rtn['content'] = apply_filters('leapin_post_widget_return_content_json', $rtn['content']);
        return $rtn;
    }

    private function get_loop_pattern($pattern, $default = "small")
    {
        if (!is_array($pattern)) return $pattern;

        $p = $default;
        $i = 0;
        $loop_index = $this->loop;
        do {
            if (array_key_exists($loop_index, $pattern)) {
                $p = $pattern[$loop_index];
                break;
            } else {
                $loop_index -= count($pattern);
            }
        } while ($i++ < 6);

        return $p;
    }

    private function get_card_ul($the_query)
    {
        $layout = $this->layout_type;
        $li_class = sprintf(" card-%d", $this->loop);

        $pattern = "";
        if ($this->is_magazine) {
            $pattern = $this->get_loop_pattern(LEAPIN_Query_Params::$MAGAZINE_PATTERN);

        } elseif ($layout === LEAPIN_Query_Params::$TILE_VER1) {
            $pattern = $this->get_loop_pattern(LEAPIN_Query_Params::$TILE1_PATTERN);

        } elseif ($layout === LEAPIN_Query_Params::$TILE_VER4) {
            $pattern = $this->get_loop_pattern(LEAPIN_Query_Params::$TILE4_PATTERN);

        } elseif ($layout === LEAPIN_Query_Params::$TILE_VER5) {
            $pattern = $this->get_loop_pattern(LEAPIN_Query_Params::$TILE5_PATTERN);

        } elseif ($layout === LEAPIN_Query_Params::$TILE_VER2) {
            $pattern = $this->get_loop_pattern(LEAPIN_Query_Params::$TILE2_PATTERN);
        } elseif ($layout === LEAPIN_Query_Params::$SIDEBAR_VER1) {
            $pattern = $this->get_loop_pattern(LEAPIN_Query_Params::$SIDE1_PATTERN);
        } else {
            $li_class .= " " . $this->font_size;
        }

        if (!empty($pattern)) {
            $li_class .= sprintf(" card-%s", $pattern);


            if ($layout === LEAPIN_Query_Params::$TILE_VER5) {
                $li_class .= " font-xsmall";

            } elseif ($pattern === "xlarge") {

                $li_class .= " font-large";

            } else {

                $li_class .= sprintf(" font-%s", $pattern);

            }
        }

        $li_class .= $this->is_swipper && !$this->is_magazine ? " swiper-slide" : "";

        ob_start();
        ?>

        <?php $this->get_card_ul_before($the_query); ?>

        <li class="card <?php echo $li_class; ?>">
            <?php echo $this->get_card_template(); ?>
        </li>

        <?php $this->get_card_ul_after($the_query); ?>

        <?php
        wp_reset_postdata();
        return ob_get_clean();
    }

    private function get_card_ul_before($the_query)
    {
        $ul_class = " ";
        $ul_class .= $this->base_layout;
        $paged = $this->paged;

        if ($this->is_magazine) {
            $ul_class .= " swiper-slide";
        } elseif ($this->is_swipper) {
            $ul_class .= " swiper-wrapper";
        } else {
            $ul_class .= "";
        }

        if (($this->is_first_loop($the_query) && !$paged)
            || ($this->is_magazine && $this->is_first_in_group())) :
            if ($this->is_swipper_separated) :
                ?>
                <div class="card__w_main">
            <?php endif; ?>
            <ul class="card__ul <?php echo $ul_class; ?>">
        <?php endif; ?>
        <?php
    }

    private function get_card_ul_after($the_query)
    {
        $layout_type = $this->layout_type;
        $paged = $this->paged;
        $more_post_label = $this->more_label;

        if (
            ($this->is_last_loop($the_query) && !$paged)
            || ($this->is_magazine && $this->is_last_in_group())
        ) : ?>
            </ul>
            <?php if ($this->is_swipper_separated) : ?>
                <?php if ($layout_type == LEAPIN_Query_Params::$SWIPER_VER4): ?>
                    <!-- Add Pagination -->
                    <div class="swiper-pagination"></div>
                <?php endif; ?>
                </div><!-- .card__w_main end -->
            <?php endif; ?>
            <?php if ($this->is_more_posts($the_query) && !LEAPIN_AMP_Tags::is_amp()): ?>

                <?php if ($layout_type == LEAPIN_Query_Params::$SIDEBAR_VER1): ?>

                    <div class="more-posts-container">
                        <a class="ajax-more-posts flat_btn transparent ripple"
                           href="#"><?php echo $more_post_label; ?></a>
                    </div>

                <?php elseif ((in_array($layout_type, [LEAPIN_Query_Params::$TILE_VER6, LEAPIN_Query_Params::$SWIPER_VER2]) || $this->is_magazine) && $this->is_last_loop($the_query)): ?>
                    <?php if (leapin_is_pro()): ?>
                        <div class="swiper-button-prev"></div>
                        <div class="swiper-button-next"></div>
                    <?php endif; ?>
                <?php elseif ($this->is_magazine ||
                    in_array($layout_type, [LEAPIN_Query_Params::$SWIPER_VER1
                        , LEAPIN_Query_Params::$SWIPER_VER3
                        , LEAPIN_Query_Params::$SWIPER_VER4])): ?>
                <?php else: ?>

                    <div class="more-posts-container">
                        <a class="ajax-more-posts round_edge_btn more ripple"
                           href="#"><?php echo $more_post_label; ?></a>
                    </div>

                <?php endif; ?>
            <?php endif; ?>
        <?php endif;
    }

    private function get_card_template()
    {

        $post_id = get_the_ID();
        $show_date = $this->show_date;
        $layout_type = $this->layout_type;
        $disp_excerpt = $this->disp_excerpt;
        // get taxonomy label and link
        $term_links = [];
        $max_term_links = $layout_type === LEAPIN_Query_Params::$TILE_VER2 ? 3 : 1;
        $thumbnail_size = $this->thumbnail_size;
        $show_taxonomy = $this->show_taxonomy;
        $dot = $this->meta_dot;
        $tax_decor = $this->get_loop_pattern($this->tax_decor, "");
        $tax_class = $dot . $tax_decor . ($show_taxonomy ? "" : " sr-only");
        if ($this->is_big_thumbnail) {
            $thumbnail_size = "large";
        }
        $thumb_id = "thumbnail-$thumbnail_size-$post_id";
        if (!empty($show_taxonomy)) {
            $term_links = $this->get_term_links($post_id, $show_taxonomy, $max_term_links);
        }

        ob_start();
        ?>
        <article <?php post_class('cf card__wrap'); ?> role="article">
            <?php do_action('leapin_post_widget_disp_on_the_corner', $this); ?>
            <?php
            $img = leapin_get_eyecatch_image($thumbnail_size);
            $thumb = $img[0];
            if (!LEAPIN_AMP_Tags::is_amp()) {
                // @todo concat ajax styles
                echo "<style>.card__thumbnail.$thumb_id::after{background-image: url($thumb)}</style>";
            }
            ?>
            <div class="card__thumbnail <?php echo " " . $thumb_id; ?>" itemprop="image" itemscope
                 itemtype="https://schema.org/ImageObject">
                <a href="<?php the_permalink(); ?>" class="ripple"></a>
                <meta itemprop="url" content="<?php echo $img[0]; ?>">
                <meta itemprop="width" content="<?php echo $img[1]; ?>">
                <meta itemprop="height" content="<?php echo $img[2]; ?>">
            </div>
            <div class="card__content">
                <div class="card__header">
                    <div class="card__meta">
                        <time class="published entry-time sr-only" datetime="<?php echo get_the_date('Y-m-d'); ?>"
                              itemprop="datePublished"></time>
                        <time class="updated entry-time sr-only"
                              datetime="<?php echo get_the_modified_date('Y-m-d'); ?>" itemprop="dateModified">May 27,
                            2018
                        </time>
                        <div class="card__date<?php echo $show_date ? '' : ' sr-only'; ?>"><?php echo get_the_date(); ?></div>
                        <div class="card__taxonomy<?php echo $tax_class; ?>">
                            <?php foreach ($term_links as $term_link) echo $term_link; ?>
                        </div>
                        <?php do_action('leapin_post_widget_disp_header_meta', $this); ?>
                    </div>
                    <p class="card__title" itemprop="headline"><a href="<?php the_permalink(); ?>"
                        ><?php LEAPIN_Single_Tags::get_the_title(); ?></a></p>
                    <meta itemprop="mainEntityOfPage" content="<?php the_permalink(); ?>">
                </div>
                <div class="card__excerpt<?php echo $disp_excerpt ?>" itemprop="articleBody">
                    <?php
                    parent::the_leapin_excerpt();
                    ?>
                </div>
                <div class="card__footer">
                    <?php
                    $read_more_label = parent::get_read_more_label();
                    $is_read_more_button = $this->is_read_more_button;
                    ?>
                    <?php if (!empty($read_more_label)): ?>
                        <?php if ($is_read_more_button): ?>
                            <a class="card__more flat_btn ripple" href="<?php the_permalink(); ?>">
                                <?php echo $read_more_label; ?>
                            </a>
                        <?php else: ?>
                            <a class="card__more ripple" href="<?php the_permalink(); ?>">
                                <i class="fas fa-bars"></i><?php echo __('More','pjax-blog') ?>
                            </a>
                        <?php endif; ?>
                    <?php endif; ?>
                    <!--                    <div class="row entry-author author sr-only" itemprop="author" itemscope-->
                    <!--                         itemtype="https://schema.org/Person">-->
                    <!--                        <span itemprop="name"> --><?php
                    //                            $user = LEAPIN_Single_Tags::get_user_name();
                    //                            echo $user;
                    //
                    ?>
                    <!--                        </span>-->
                    <!--                    </div>-->
                    <!--                    --><?php //LEAPIN_Single_Tags::the_publisher_markup();
                    ?>
                </div>
                <?php if (in_array($layout_type, [LEAPIN_Query_Params::$SWIPER_VER1])): ?>
                    <div class="swiper-pagination"></div>
                <?php endif; ?>
            </div>
            <?php if (in_array($layout_type, [LEAPIN_Query_Params::$SWIPER_VER3])): ?>
                <div class="swiper-pagination"></div>
            <?php endif; ?>
        </article>
        <?php
        return ob_get_clean();
    }

    private function get_term_links($post_id, $show_taxonomy, $max_term_links)
    {
        $term_links = [];
        $terms = wp_get_post_terms($post_id, $show_taxonomy);
        foreach ($terms as $i => $term) {
            if ($i > $max_term_links - 1) break;
            $term_id = $term->term_id;
            $term_label = $term->name;
            $term_url = get_term_link($term_id);
            if (!is_wp_error($term_url)) {
                $term_links[] = sprintf('<a class="terms term-%s" href="%s">%s</a>', $term_id, $term_url, $term_label);
            }
        }
        return $term_links;
    }

    private function get_background_ul($the_query)
    {
        $post_id = get_the_ID();
        $thumbnail_size = $this->thumbnail_size;
        if ($this->is_big_thumbnail) {
            $thumbnail_size = "large";
        }
        $thumb_id = "thumbnail-$thumbnail_size-$post_id";
        $img = leapin_get_eyecatch_image($thumbnail_size);
        $thumb = $img[0];
        $paged = $this->paged;
        ob_start();
        ?>
        <?php if ($this->is_first_loop($the_query) && !$paged) : ?>
        <div class="card__w_bg">
        <ul class="card__ul swiper-wrapper bg">
    <?php endif; ?>

        <li class="card swiper-slide">
            <div class="card__thumbnail <?php echo $thumb_id; ?>" itemprop="image" itemscope
                 itemtype="https://schema.org/ImageObject">
                <meta itemprop="url" content="<?php echo $img[0]; ?>">
                <meta itemprop="width" content="<?php echo $img[1]; ?>">
                <meta itemprop="height" content="<?php echo $img[2]; ?>">
            </div>
        </li>

        <?php if ($this->is_last_loop($the_query) && !$paged) : ?>
        </ul>
        </div>
    <?php endif;
        return ob_get_clean();
    }
}
