<?php
/**
 * Sidebar Widget Setting
 *
 * @author LeapIn Corp.
 * @since 1.0.0
 */
$panel = 'leapin_settings';
$section = 'leapin_sidebar_widgets';
$wp_customize->add_section($section_id = $section, array(
    'title' => __('Sidebar', 'pjax-blog'),
    'description' => '<em>' . __('You can change the appearance of your sidebar widgets here', 'pjax-blog') . '</em>', // Include html tags such as <p>.
    'priority' => 64, // Mixed with top-level-section hierarchy.
    'panel' => $panel,
));

/**
 * Widget Title Type
 */
$wp_customize->add_setting($setting_id = LEAPIN_IDs::$leapin_sidebar_widget_title_type, array(
    'type' => 'theme_mod', // or 'option'
    'capability' => 'manage_options',
    'default' => LEAPIN_Theme_Mod::$default_leapin_sidebar_widget_title_type,
    'transport' => LEAPIN_IDs::$refresh,
    'sanitize_callback' => 'leapin_sanitize_text',
));

$wp_customize->add_control(LEAPIN_IDs::$leapin_sidebar_widget_title_type, array(
    'type' => 'select',
    'label' => __('Widget Title Type', 'pjax-blog'),
    'section' => $section,
    'choices' => LEAPIN_Theme_Mod::$choice_leapin_sidebar_widget_title_type,
));

/**
 * Widgets Title Color
 */
$wp_customize->add_setting($setting_id = LEAPIN_IDs::$leapin_sidebar_widget_title_color, array(
    'type' => 'theme_mod', // or 'option'
    'capability' => 'manage_options',
    'default' => '',
    'transport' => LEAPIN_IDs::$postMessage,
    'sanitize_callback' => 'leapin_sanitize_rgba_color'
));

$wp_customize->add_control(new LEAPIN_Customize_Alpha_Color_Control($wp_customize, LEAPIN_IDs::$leapin_sidebar_widget_title_color, array(
    'label' => __('Title Font Color', 'pjax-blog'),
    'section' => $section,
    'settings' => LEAPIN_IDs::$leapin_sidebar_widget_title_color,
    'show_opacity'  => true,
)));

/**
 * Widgets Title Theme Color
 */
$wp_customize->add_setting($setting_id = LEAPIN_IDs::$leapin_sidebar_widget_title_theme_color, array(
    'type' => 'theme_mod', // or 'option'
    'capability' => 'manage_options',
    'default' => '',
    'transport' => LEAPIN_IDs::$refresh,
    'sanitize_callback' => 'leapin_sanitize_rgba_color'
));

$wp_customize->add_control(new LEAPIN_Customize_Alpha_Color_Control($wp_customize, LEAPIN_IDs::$leapin_sidebar_widget_title_theme_color, array(
    'label' => __('Title Theme Color', 'pjax-blog'),
    'section' => $section,
    'settings' => LEAPIN_IDs::$leapin_sidebar_widget_title_theme_color,
    'show_opacity'  => true,
)));

/**
 * Widgets Title Border Color
 */
$wp_customize->add_setting($setting_id = LEAPIN_IDs::$leapin_sidebar_widget_title_border_color, array(
    'type' => 'theme_mod', // or 'option'
    'capability' => 'manage_options',
    'default' => '',
    'transport' => LEAPIN_IDs::$refresh,
    'sanitize_callback' => 'leapin_sanitize_rgba_color'
));

$wp_customize->add_control(new LEAPIN_Customize_Alpha_Color_Control($wp_customize, LEAPIN_IDs::$leapin_sidebar_widget_title_border_color, array(
    'label' => __('Title Border Color', 'pjax-blog'),
    'section' => $section,
    'settings' => LEAPIN_IDs::$leapin_sidebar_widget_title_border_color,
    'show_opacity'  => true,
)));

/**
 * Widgets Title Border Radius
 */
$wp_customize->add_setting($setting_id = LEAPIN_IDs::$leapin_sidebar_widget_title_border_radius, array(
    'type' => 'theme_mod', // or 'option'
    'capability' => 'manage_options',
    'transport' => LEAPIN_IDs::$refresh,
    'default' => LEAPIN_Theme_Mod::$default_leapin_sidebar_widget_title_border_radius,
    'sanitize_callback' => 'leapin_sanitize_number',
));
$wp_customize->add_control(LEAPIN_IDs::$leapin_sidebar_widget_title_border_radius, array(
    'label' => __('Title Border Radius(px):', 'pjax-blog'),
    'section' => $section,
    'type' => 'number',
));

/**
 * Widgets Border Radius
 */
$wp_customize->add_setting($setting_id = LEAPIN_IDs::$leapin_sidebar_widget_border_radius, array(
    'type' => 'theme_mod', // or 'option'
    'capability' => 'manage_options',
    'transport' => LEAPIN_IDs::$refresh,
    'default' => LEAPIN_Theme_Mod::$default_leapin_sidebar_widget_border_radius,
    'sanitize_callback' => 'leapin_sanitize_number',
));
$wp_customize->add_control(LEAPIN_IDs::$leapin_sidebar_widget_border_radius, array(
    'label' => __('Content Border Radius(px):', 'pjax-blog'),
    'section' => $section,
    'type' => 'number',
));

/**
 * Links Color
 */
$wp_customize->add_setting($setting_id = LEAPIN_IDs::$leapin_sidebar_links_color, array(
    'type' => 'theme_mod', // or 'option'
    'capability' => 'manage_options',
    'default' => '',
    'transport' => LEAPIN_IDs::$postMessage,
    'sanitize_callback' => 'leapin_sanitize_rgba_color'
));

$wp_customize->add_control(new LEAPIN_Customize_Alpha_Color_Control($wp_customize, LEAPIN_IDs::$leapin_sidebar_links_color, array(
    'label' => __('Links', 'pjax-blog'),
    'section' => $section,
    'settings' => LEAPIN_IDs::$leapin_sidebar_links_color,
    'show_opacity'  => true,
)));

/**
 * Links:hover Color
 */
$wp_customize->add_setting($setting_id = LEAPIN_IDs::$leapin_sidebar_links_color_hover, array(
    'type' => 'theme_mod', // or 'option'
    'capability' => 'manage_options',
    'default' => '',
    'transport' => LEAPIN_IDs::$refresh,
    'sanitize_callback' => 'leapin_sanitize_rgba_color'
));

$wp_customize->add_control(new LEAPIN_Customize_Alpha_Color_Control($wp_customize, LEAPIN_IDs::$leapin_sidebar_links_color_hover, array(
    'label' => __('Links Hover', 'pjax-blog'),
    'section' => $section,
    'settings' => LEAPIN_IDs::$leapin_sidebar_links_color_hover,
    'show_opacity'  => true,
)));

/**
 * Accent Color
 */
$wp_customize->add_setting($setting_id = LEAPIN_IDs::$leapin_sidebar_widgets_hover_underline_color, array(
    'type' => 'theme_mod', // or 'option'
    'capability' => 'manage_options',
    'default' => '',
    'transport' => LEAPIN_IDs::$refresh,
    'sanitize_callback' => 'leapin_sanitize_rgba_color'
));

$wp_customize->add_control(new LEAPIN_Customize_Alpha_Color_Control($wp_customize, LEAPIN_IDs::$leapin_sidebar_widgets_hover_underline_color, array(
    'label' => __('Accent Color', 'pjax-blog'),
    'section' => $section,
    'settings' => LEAPIN_IDs::$leapin_sidebar_widgets_hover_underline_color,
    'show_opacity'  => true,
)));

