'use strict';

/**********************************
 * scroll script file of Pjax blog
 * @since v1.0.0
 * @link https://leap-in.com
 * @author LeapIn Corp
 * */
var LEAPIN_SCROLL = (function () {
    'use strict';
    var observers = {};

    var destroy = function() {
        for (var key in observers) {
            observers[key].disconnect();
        }
    };

    var trigger = function(identifier, elements, callback, options) {
        options = options ? options : {};
        var io = new IntersectionObserver(callback, options);
        // set interval for polyfill
        // @see https://github.com/w3c/IntersectionObserver/tree/master/polyfill
        io.POLL_INTERVAL = 100;

        elements.forEach(function (element) {
            if(element){
                io.observe(element);
            }
        });

        observers[identifier] = io;
        return false;
    };

    return {
        trigger: trigger,
        destroy: destroy
    };
}());